unit aamshtmlpscl;

{$MODE DELPHI}{$H+}

interface

uses
  SysUtils, Classes, Controls, mscoreengine, msrtti_classes, HTMLView, HTMLUn2, uHtmlPscl, Dialogs;

implementation

type
  TLibrary_HTMLPSCL = class(TmscrRTTILibrary)
  private
    procedure RegisterProcs(AScript: TmscrScript);
    procedure RegisterClasses(AScript: TmscrScript);
    function  ProcCallMethod(aInstance: TObject; aClassType: TClass; const aMethodName: string; aCallVar: TmscrVarForMethod): variant;
    function  ClassCallMethod(aInstance: TObject; aClassType: TClass; const aMethodName: string; aCallVar: TmscrVarForMethod): variant;
  public
    constructor Create(AScript: TmscrScript); override;
  end;

constructor TLibrary_HTMLPSCL.Create(AScript: TmscrScript);
begin
  inherited Create(AScript);
  RegisterProcs(AScript);
  RegisterClasses(AScript);
end;

procedure TLibrary_HTMLPSCL.RegisterProcs(AScript: TmscrScript);
begin
  //... HTMLView/psclHTML
  AScript.Register_Method('function HTMLGetValue(html: THtmlPscl; elemento:String; Valor: Variant): Variant', ProcCallMethod);
  AScript.Register_Method('function HTMLSetValue(html: THtmlPscl; elemento:String; Valor: Variant): Variant', ProcCallMethod);
  //
  AScript.Register_Method('function ConsoleMsg(html: THtmlPscl; msg:String): boolean', ProcCallMethod);
  AScript.Register_Method('function ConsoleActivate(html: THtmlPscl; atv:boolean): boolean', ProcCallMethod);
  //
end;

function TLibrary_HTMLPSCL.ProcCallMethod(aInstance: TObject; aClassType: TClass; const aMethodName: string; aCallVar: TmscrVarForMethod): variant;
begin
  Result := 0;
  if aMethodName = 'HTMLGETVALUE' then begin
    Result := uHtmlPscl.funcHTMLGetValue( THtmlPscl(Integer(aCallVar.Params[0])),aCallVar.Params[1],aCallVar.Params[2] );
  exit; end;
  if aMethodName = 'HTMLSETVALUE' then begin
    Result := uHtmlPscl.funcHTMLSetValue( THtmlPscl(Integer(aCallVar.Params[0])),aCallVar.Params[1],aCallVar.Params[2] );
  exit; end;
  //
  //  AScript.Register_Method('function ConsoleMsg(html: THtmlPscl; msg:String): boolean', ProcCallMethod);
  if aMethodName = 'CONSOLEMSG' then begin
     if Assigned(THtmlPscl(Integer(aCallVar.Params[0])).memoConsole) then
        if THtmlPscl(Integer(aCallVar.Params[0])).ConsoleActive then THtmlPscl(Integer(aCallVar.Params[0])).memoConsole.Lines.Add(TimeToStr(NOW)+': '+ aCallVar.Params[1]);
     Result := THtmlPscl(Integer(aCallVar.Params[0])).ConsoleActive;
  exit; end;
  //  AScript.Register_Method('function ConsoleActive(html: THtmlPscl; elemento:String): boolean', ProcCallMethod);
  if aMethodName = 'CONSOLEACTIVATE' then begin
     Result := THtmlPscl(Integer(aCallVar.Params[0])).ConsoleActive;
     THtmlPscl(Integer(aCallVar.Params[0])).ConsoleActive:= aCallVar.Params[1];
  exit; end;

end;

procedure TLibrary_HTMLPSCL.RegisterClasses(AScript: TmscrScript);
begin
  with AScript do
  begin
    with Register_Class(ThvPanel, 'ThvPanel') do
    begin
      Register_Method('procedure Hide', ClassCallMethod);
      Register_Method('procedure Show', ClassCallMethod);
      Register_Method('Function SetVisible(flag:Boolean):Boolean',ClassCallMethod);
    end;
  end;
end;

function TLibrary_HTMLPSCL.ClassCallMethod(aInstance: TObject; aClassType: TClass; const aMethodName: string; aCallVar: TmscrVarForMethod): variant;
begin
  Result := 0;
  if aClassType = ThvPanel then begin
      if aMethodName = 'HIDE' then begin
         ThvPanel(aInstance).Visible := FALSE; exit; end;
  end;
  if aClassType = ThvPanel then begin
      if aMethodName = 'SHOW' then begin
         ThvPanel(aInstance).Visible := TRUE; exit; end;
  end;
  if aClassType = ThvPanel then begin
      if aMethodName = 'SETVISIBLE' then begin
         ThvPanel(aInstance).Visible := aCallVar.Params[0]; exit; end;
  end;
  //
end;

initialization
  MSCR_RTTILibraries.Add(TLibrary_HTMLPSCL);

finalization
  MSCR_RTTILibraries.Remove(TLibrary_HTMLPSCL);

end.

