unit uprincipal;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
 ComCtrls, Buttons, SynEdit, SynHighlighterHTML, msScriptEditor, Clipbrd,
 msScriptHighlighter, AAStatusBar, utabsbuttons, SynEditTypes,
 uHtmlPscl, aamshtmlpscl;

type

 { TfrmPrincipal }

 TfrmPrincipal = class(TForm)
  AAStatusBar: TAAStatusBar;
  btnColorHTML: TBitBtn;
  btnColorScript: TBitBtn;
  btnNewHTML: TBitBtn;
  btnNewScript: TBitBtn;
  btnOpenHTML: TBitBtn;
  btnOpenScript: TBitBtn;
  btnSaveAsHTML: TBitBtn;
  btnSaveAsScript: TBitBtn;
  btnSaveHTML: TBitBtn;
  btnSaveScript: TBitBtn;
  btnViewHTML: TBitBtn;
  btnViewScript: TBitBtn;
  ColorDialog: TColorDialog;
  grpPSCL: TGroupBox;
  grpHTML: TGroupBox;
  grpTHtmlPscl: TGroupBox;
  grpConsole: TGroupBox;
  HtmlPscl1: THtmlPscl;
  HtmlPscl2: THtmlPscl;
  ImageList1: TImageList;
  memoConsole: TMemo;
  OpenDialog: TOpenDialog;
  SaveDialog: TSaveDialog;
  SynEditPSCL: TmscrScriptEditor;
  mscrScriptHighlighter1: TmscrScriptHighlighter;
  pageProjeto: TPageControl;
  pagePrincipal: TPageControl;
  Panel1: TPanel;
  Panel2: TPanel;
  Panel3: TPanel;
  Panel4: TPanel;
  Panel5: TPanel;
  Panel6: TPanel;
  pnlHTML: TPanel;
  pnlScript: TPanel;
  Splitter1: TSplitter;
  Splitter2: TSplitter;
  SynEditHTML: TSynEdit;
  SynHTMLSyn1: TSynHTMLSyn;
  tabHTML: TTabSheet;
  tabScript: TTabSheet;
  tabTHtmlPscl: TTabSheet;
  tabProjeto: TTabSheet;
  procedure btnColorClick(Sender: TObject);
  procedure btnNewHTMLClick(Sender: TObject);
  procedure btnNewScriptClick(Sender: TObject);
  procedure btnOpenHTMLClick(Sender: TObject);
  procedure btnOpenScriptClick(Sender: TObject);
  procedure btnSaveAsHTMLClick(Sender: TObject);
  procedure btnSaveAsScriptClick(Sender: TObject);
  procedure btnSaveHTMLClick(Sender: TObject);
  procedure btnSaveScriptClick(Sender: TObject);
  procedure btnViewClick(Sender: TObject);
  //
  procedure FormCreate(Sender: TObject);
  procedure SynEditHTMLStatusChange(Sender: TObject; Changes: TSynStatusChanges
   );
  procedure SynEditPSCLStatusChange(Sender: TObject; Changes: TSynStatusChanges
   );
 private
   htmlAlterado : Boolean;
   psclAlterado : Boolean;
 public

 end;

var
 frmPrincipal: TfrmPrincipal;

implementation

{$R *.frm}

{ TfrmPrincipal }

procedure TfrmPrincipal.FormCreate(Sender: TObject);
begin
   HtmlPscl1.LoadFromFile('html\thtmlpscl.html');
   //
   HtmlPscl2.memoConsole   := memoConsole;
   HtmlPscl2.ConsoleActive := true;
   //
   htmlAlterado := false;
   psclAlterado := false;
end;

procedure TfrmPrincipal.SynEditHTMLStatusChange(Sender: TObject; Changes: TSynStatusChanges);
begin
   htmlAlterado := scModified in Changes;
end;

procedure TfrmPrincipal.SynEditPSCLStatusChange(Sender: TObject; Changes: TSynStatusChanges);
begin
   psclAlterado := scModified in Changes;
end;

//-------------------------------------------------------------------------------------------------
procedure TfrmPrincipal.btnNewHTMLClick(Sender: TObject);
begin
   if htmlAlterado then begin
      if MessageDlg('Source NOT saved!','Discard changes?',mtInformation,[mbOk,mbCancel],0)=mrCancel then EXIT;
   end;
   utabsbuttons.New(grpHTML,SynEditHTML);
   utabsbuttons.NewCodeHTML(SynEditHTML);
   htmlAlterado := TRUE;
end;

procedure TfrmPrincipal.btnOpenHTMLClick(Sender: TObject);
begin
   if htmlAlterado then begin
      if MessageDlg('Source NOT saved!','Discard changes?',mtInformation,[mbOk,mbCancel],0)=mrCancel then EXIT;
   end;
   uTabsButtons.Open(OpenDialog,'Open HTML','.html|.htm','HTML|*.html|HTM|*.htm',grpHTML,SynEditHTML) ;
end;

procedure TfrmPrincipal.btnSaveHTMLClick(Sender: TObject);
begin
  if uTabsButtons.Save(SaveDialog,'Save HTML','.html|.htm','HTML|*.html|HTM|*.htm',grpHTML,SynEditHTML) then
     htmlAlterado := FALSE;
end;

procedure TfrmPrincipal.btnSaveAsHTMLClick(Sender: TObject);
begin
  if uTabsButtons.SaveAs(SaveDialog,'Save HTML','.html|.htm','HTML|*.html|HTM|*.htm',grpHTML,SynEditHTML) then
     htmlAlterado := FALSE;
end;
//-------------------------------------------------------------------------------------------------
procedure TfrmPrincipal.btnNewScriptClick(Sender: TObject);
begin
   if psclAlterado then begin
      if MessageDlg('Source NOT saved!','Discard changes?',mtInformation,[mbOk,mbCancel],0)=mrCancel then EXIT;
   end;
   utabsbuttons.New(grpPSCL,SynEditHTML);
   utabsbuttons.NewCodePSCL(SynEditPSCL);
   psclAlterado := TRUE;
end;

procedure TfrmPrincipal.btnOpenScriptClick(Sender: TObject);
begin
   if psclAlterado then begin
      if MessageDlg('Source NOT saved!','Discard changes?',mtInformation,[mbOk,mbCancel],0)=mrCancel then EXIT;
   end;
   uTabsButtons.Open(OpenDialog,'Open Script','.pscl','Pascal Script|*.pscl',grpPSCL,SynEditPSCL) ;
end;

procedure TfrmPrincipal.btnSaveScriptClick(Sender: TObject);
begin
  if uTabsButtons.Save(SaveDialog,'Save Script','.pscl','Pascal Script|*.pscl',grpPSCL,SynEditPSCL) then
     psclAlterado := FALSE;
end;

procedure TfrmPrincipal.btnSaveAsScriptClick(Sender: TObject);
begin
  if uTabsButtons.SaveAs(SaveDialog,'Save Script','.pscl','Pascal Script|*.pscl',grpPSCL,SynEditPSCL) then
     psclAlterado := FALSE;
end;
//-------------------------------------------------------------------------------------------------
procedure TfrmPrincipal.btnColorClick(Sender: TObject);
begin
  if ColorDialog.Execute then begin
     ClipBoard.AsText := ColorToString (ColorDialog.Color );
  end;
end;

procedure TfrmPrincipal.btnViewClick(Sender: TObject);
begin
   HtmlPscl2.LoadFromString('');
   HtmlPscl2.pscl.Clear;
   HtmlPscl2.ActiveViewer.Clear;
   HtmlPscl2.ActiveViewer.LoadFromString( UnicodeString(SynEditHTML.Text)  );
   HtmlPscl2.ScriptExec;
end;
//-------------------------------------------------------------------------------------------------

end.

