unit uTabsButtons;

{$mode ObjFPC}{$H+}

interface

uses
 Classes, SysUtils, StdCtrls, SynEdit, Dialogs;

   procedure New(grp: TGroupBox; editor: TSynEdit);
   procedure Open(dialog: TOpenDialog; ttl:String; ext:String; filter:String; grp: TGroupBox; editor: TSynEdit);
   function  Save(dialog: TSaveDialog; ttl:String; ext:String; filter:String; grp: TGroupBox; editor: TSynEdit): Boolean;
   function SaveAs(dialog: TSaveDialog; ttl:String; ext:String; filter:String; grp: TGroupBox; editor: TSynEdit): Boolean ;
   //
   procedure NewCodeHTML(editor: TSynEdit);
   procedure NewCodePSCL(editor: TSynEdit);
   //

implementation
//-------
procedure New(grp: TGroupBox; editor: TSynEdit);
begin
  grp.Caption:= '';
  editor.Lines.Clear;
end;
//-------
procedure Open(dialog: TOpenDialog; ttl:String; ext:String; filter:String; grp: TGroupBox; editor: TSynEdit);
begin
  dialog.Title      := ttl;
  dialog.DefaultExt := ext;
  dialog.Filter     := filter;
  dialog.FileName   := '';
  if (dialog.Execute) then begin
     grp.Caption:= dialog.FileName;
     editor.Lines.LoadFromFile(dialog.FileName);
  end;
end;
//-------
function Save(dialog: TSaveDialog; ttl:String; ext:String; filter:String; grp: TGroupBox; editor: TSynEdit):Boolean;
begin
  dialog.Title      := ttl;
  dialog.DefaultExt := ext;
  dialog.Filter     := filter;
  dialog.FileName   := '';
  if (Trim(grp.Caption) = '') then begin
      if dialog.Execute then  begin
         grp.Caption:=dialog.FileName;
         editor.Lines.SaveToFile(grp.Caption);
         Result := TRUE;
      end
      else Result := FALSE;
  end
  else begin
    editor.Lines.SaveToFile(grp.Caption);
    Result := TRUE;
  end;
end;
//-------
function SaveAs(dialog: TSaveDialog; ttl:String; ext:String; filter:String; grp: TGroupBox; editor: TSynEdit):Boolean;
begin
  dialog.Title      := ttl;
  dialog.DefaultExt := ext;
  dialog.Filter     := filter;
  dialog.FileName   := ExtractFileName(grp.Caption);
  if dialog.Execute then  begin
     grp.Caption:=dialog.FileName;
     editor.Lines.SaveToFile(grp.Caption);
     Result := TRUE;
  end
  else Result := FALSE;
end;
//-------
procedure NewCodeHTML(editor: TSynEdit);
begin
  editor.Lines.Text := '<!--' + #13#10 +
                       'THtmlPscl 1.0/10.22 THtmlViewer with MagicScript'  + #13#10 +
                       'Augusto Angelim' + #13#10 +
                       DateTimeToStr(NOW) + #13#10 +
                       '-->' + #13#10 +
                       '<!DOCTYPE html>' + #13#10 +
                       '<html lang="pt-br">' + #13#10 +
                       '<head>' + #13#10 +
                       '   <meta charset="UTF-8" />' + #13#10 +
                       '   <meta name="viewport" content="width=device-width, initial-scale=1.0" />' + #13#10 +
                       '   <title>THtmlPscl</title>' + #13#10 +
                       '</head>' + #13#10 +
                       '<body>' + #13#10 +
                       '</body>' + #13#10 +
                       '</html>' + #13#10;
end;

procedure NewCodePSCL(editor: TSynEdit);
begin
  editor.Lines.Text := '// THtmlPscl 1.0/10.22 THtmlViewer with MagicScript' + #13#10 +
                       '// Augusto Angelim' + #13#10 +
                       '// ' + DateTimeToStr(NOW) + #13#10 +
                       '//--------------------------------------------------' + #13#10 +
                       'program ScriptName;'+ #13#10 +
                       'begin' + #13#10 + #13#10 +
                       'end.'  + #13#10;
end;

end.

