unit uHtmlPscl;

{$mode ObjFPC}{$H+}

interface

uses
    LclIntf, HtmlMisc,
    Classes, SysUtils, StdCtrls, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
    ComCtrls, LCLType, Menus, UxTheme, Clipbrd, Buttons, HtmlGlobals, HTMLUn2, TypInfo,
    mscoreengine, msrtti_forms, msrtti_graphics, msrtti_classes, msrtti_extctrls,
    msrtti_inifiles, msrtti_menus, msrtti_dialogs, msrtti_db, msrtti_dbctrls,
    HTMLSBS1, HTMLSubs, Variants, lazutf8, FramView, HtmlView;

type
  THtmlPscl = class(TFrameViewer)
  private
  protected
  public
     pscl : TmscrPascalScript;
     DocumentPanel : TPaintPanel;
     ContentScript : String;
     memoConsole : TMemo;
     ConsoleActive: Boolean;
     //
     constructor Create(AOwner: TComponent); override;
     function    GetPaintPanel(obj:TComponent; classe:TClass; s:String) :TPaintPanel;
     procedure   ScriptExec;
     procedure   Console(s: String);
     procedure   ConsoleHtmlPscl(s: String);
     procedure   LoadScript(s:String);
     procedure   HTMLAddControls;
     //
     procedure   HTMLObjectClick(Sender, Obj: TObject; const OnClickStr: ThtString);
     procedure   HTMLPanelCreate(Sender: TObject; const AName, AType, SRC: ThtString; Panel: ThvPanel);
     procedure   HTMLScript(Sender: TObject; const AName, ContentType, Src, Script: ThtString);
  published
  end;

  // Funções auxiliares da interface HTML<->MagicScript
  function HTMLGetValue(html: THtmlPscl;  elemento:String; Valor: String):String;
  function funcHTMLGetValue(obj:THtmlPscl; elemento:String; Valor: String):String;
  //
  function HTMLSetValue(html: THtmlPscl;  elemento:String; Valor: String):String;
  function funcHTMLSetValue(obj:THtmlPscl; elemento:String; Valor: String):String;
  //-------------------------------------------------------------------------------
  function IfInLine(b1,b2,b3:Boolean):Boolean;

procedure Register;

implementation

constructor THtmlPscl.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   //
   ConsoleActive := FALSE;
   //
   pscl := TmscrPascalScript.Create(Self);      // Create MagicScript
   //
   Self.OnObjectClick := @HTMLObjectClick;      // Handle "OnClick" from HTML File
   Self.OnPanelCreate := @HTMLPanelCreate;      // Add Panels from HTML file!
   Self.OnScript      := @HTMLScript;           // Script from HTML file header!
   //
   pscl.RegisterRTTI2Application;               // Add todos os componentes
   pscl.ProcessDiretives;                       // Diretivas do Script  "{form:fileform.dfm}"
end;
//----------------------------------------------------------------------------------------------------------------------
procedure THtmlPscl.ScriptExec;
begin
   //
   if (pscl.Lines.Count = 0 ) then begin
       ConsoleHtmlPscl('Não há Script carregado!');
       EXIT;
   end;
   DocumentPanel := GetPaintPanel(Self,TPaintPanel,'>');                    // Get Panel from THtmlViewer
   if Assigned(DocumentPanel) then Console('DocumentPanel: '+ DocumentPanel.ClassName)
   else Console('DocumentPanel é "nil"');
   //
   pscl.ScriptPath  := Application.Location ;
   pscl.IncludePath.Add( Application.Location );
   //
   Self.OnObjectClick := @HTMLObjectClick;      // Handle "OnClick" from HTML File
   Self.OnPanelCreate := @HTMLPanelCreate;      // Add Panels from HTML file!
   Self.OnScript      := @HTMLScript;           // Script from HTML file header!
   //
   pscl.AddRTTI;                                         // Add componentes
   //
   pscl.Register_Component(Self.Parent);                 // É o TForm
   pscl.Register_Component(Self);                        // É o THtmlViewer
   //
   pscl.Register_Class(THtmlViewer,'THtmlViewer');
   pscl.Register_Class(THtmlPscl,'THtmlPscl');
   pscl.Register_Class(TPaintPanel,'TPaintPanel');
   pscl.Register_Class(ThvPanel,'ThvPanel');
   //
   pscl.Register_Const('T','String','T');                // Constant like TRUE to HTMLSetValue(DocumentHTML,'c1',T);
   pscl.Register_Const('F','String','F');                // Constant like FALSE to HTMLSetValue(DocumentHTML,'c1',F);
   //
   pscl.Register_Object('Self',Self.Parent);             // É o Form que ativa o "psclHTML"
   pscl.Register_Object('DocumentHTML',Self);            // É o THMMLViewer
   pscl.Register_Object('DocumentPanel',DocumentPanel);  // É o "panel" que o HTMLView utiliza
   pscl.Register_Object('memoConsole',Self.memoConsole);
   //
   HTMLAddControls;
   //
   if pscl.Compile then begin
     pscl.Execute;
   end
   else begin
       if Assigned(memoConsole) then                     // On Form add: HtmlPscl1.memoConsole := Memo1;
            ConsoleHtmlPscl('Erro: ' + pscl.ErrorMsg + #13#10 + 'L/C: ' + pscl.ErrorPos )
       else ShowMessage('Erro: ' + pscl.ErrorMsg + #13#10 + 'L/C: ' + pscl.ErrorPos );
//       Console(pscl.Lines.Text);
   end;
end;

//----------------------------------------------------------------------------------------------------------------------
procedure THtmlPscl.HTMLAddControls;
var
  I:Integer;
begin
   for I:=0 to Self.ActiveViewer.FormControlList.Count-1 do begin
       Self.pscl.Register_Class(Self.ActiveViewer.FormControlList.Items[I].TheControl.ClassType, Self.ActiveViewer.FormControlList.Items[I].TheControl.ClassName );
       Self.pscl.Register_Object( AnsiString(Self.ActiveViewer.FormControlList.Items[I].Name), Self.ActiveViewer.FormControlList.Items[I].TheControl);

       Console(IntToStr(I) + '-'+  Self.ActiveViewer.FormControlList.Items[I].TheControl.ClassName + '=>' + AnsiString(Self.ActiveViewer.FormControlList.Items[I].Name) );
//       Console(  AnsiString(Self.ActiveViewer.FormControlList.Items[I].ClassName) + '=>' + AnsiString(Self.ActiveViewer.FormControlList.Items[I].Name) );
   end;
end;
//----------------------------------------------------------------------------------------------------------------------
procedure THtmlPscl.ConsoleHtmlPscl(s: String);
begin
   if Assigned(memoConsole) then
        memoConsole.Lines.Add(TimeToStr(NOW)+ ' ' +s)
   else ShowMessage(s);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure THtmlPscl.Console(s: String);
begin
   if NOT ConsoleActive         then EXIT;
   if NOT Assigned(memoConsole) then EXIT;
   memoConsole.Lines.Add(TimeToStr(NOW)+ ' ' +s);
end;
//----------------------------------------------------------------------------------------------------------------------
procedure THtmlPscl.LoadScript(s:String);
begin
   Console(s);
   Self.pscl.Lines.LoadFromFile(s);
end;
//----------------------------------------------------------------------------------------------------------------------
function THtmlPscl.GetPaintPanel(obj:TComponent; classe:TClass; s:String) :TPaintPanel;
var
  I:Integer;
begin
  Result := nil;
    for I:=0 to obj.ComponentCount-1 do begin
        Console(s + obj.Components[I].ClassName);
        if (obj.ClassType = classe) then begin
            Result := TPaintPanel(obj);
            exit;
        end
        else begin
             Result := GetPaintPanel(obj.Components[I], classe, s+'>');
             if Assigned(Result) then EXIT;
        end;
    end;
end;

//======================================================================================================================
function IfInLine(b1,b2,b3:Boolean):Boolean;
begin
  if (b1) then Result := b2
  else Result := b3;
end;
//======================================================================================================================
function HTMLGetValue(html: THtmlPscl; elemento:String; Valor: String):String;
var
  I:Integer;
begin
   for I:=0 to html.ActiveViewer.FormControlList.Count-1 do begin
       if (UpperCase(UnicodeString(elemento)) = UpperCase(html.ActiveViewer.FormControlList.Items[I].Name) ) then begin
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TEditFormControlObj) then begin
               Result := AnsiString(TEditFormControlObj(html.ActiveViewer.FormControlList.Items[I]).Text);
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TTextAreaFormControlObj) then begin
               Result := AnsiString(TTextAreaFormControlObj(html.ActiveViewer.FormControlList.Items[I]).Text);
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TButtonFormControlObj) then begin
               Result := TButtonFormControlObj(html.ActiveViewer.FormControlList.Items[I]).TheControl.Caption;
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TComboFormControlObj) then begin
               Result := TComboFormControlObj(html.ActiveViewer.FormControlList.Items[I]).TheControl.Caption;
               Exit;
           end;
       end;
   end;
   result := valor;
end;
//------------------------
function funcHTMLGetValue(obj:THtmlPscl; elemento:String; Valor: String):String;
begin
   Result := HTMLGetValue( THtmlPscl(obj) , elemento, valor);
end;
//----------------------------------------------------------------------------------
function HTMLSetValue(html: THtmlPscl; elemento:String; Valor: String):String;
var
  I:Integer;
begin
   for I:=0 to html.ActiveViewer.FormControlList.Count-1 do begin
       if (UpperCase(UnicodeString(elemento)) = UpperCase(html.ActiveViewer.FormControlList.Items[I].Name) ) then begin
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TEditFormControlObj) then begin
               TEditFormControlObj(html.ActiveViewer.FormControlList.Items[I]).Text := UnicodeString(Valor);
               Result := Valor;
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TTextAreaFormControlObj) then begin
               TTextAreaFormControlObj(html.ActiveViewer.FormControlList.Items[I]).Text := UnicodeString(Valor);
               Result := Valor;
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TButtonFormControlObj) then begin
               TButtonFormControlObj(html.ActiveViewer.FormControlList.Items[I]).TheControl.Caption  := Valor;
               Result := Valor;
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TComboFormControlObj) then begin
               TComboFormControlObj(html.ActiveViewer.FormControlList.Items[I]).TheControl.Caption := Valor;
               Result := Valor;
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TCheckBoxFormControlObj) then begin
//               TCheckBoxFormControlObj(html.ActiveViewer.FormControlList.Items[I]).Value   := UnicodeString(Valor);
               TCheckBoxFormControlObj(html.ActiveViewer.FormControlList.Items[I]).Checked := Boolean(  Integer( Valor ) );//IfInLine(Valor = 'T',TRUE,FALSE);
               Result := Valor;
               Exit;
           end;
           if (html.ActiveViewer.FormControlList.Items[I].ClassType = TRadioButtonFormControlObj) then begin
               TRadioButtonFormControlObj(html.ActiveViewer.FormControlList.Items[I]).Checked := Boolean( Integer( Valor ) );//IfInLine(Valor = 'T',TRUE,FALSE);
               Result := Valor;
               Exit;
           end;

       end;
   end;
   result := '0';
end;
//-----------------------
function funcHTMLSetValue(obj:THtmlPscl; elemento,valor:String):String;
begin
  Result := HTMLSetValue( THtmlPscl(obj) , elemento, valor);
end;
//======================================================================================================================
procedure THtmlPscl.HTMLObjectClick(Sender, Obj: TObject; const OnClickStr: ThtString);
var
   ret : Variant;
begin
   ret := '';
   if (Trim(OnClickStr) = '') then EXIT;
   Console('OnClickStr: '+ AnsiString( OnClickStr ));          // OnClick from Html File: "<input type="button" value="Submit" name="B1"  onClick="OnClickMeB1">"
   ret := pscl.CallFunction(AnsiString(OnClickStr),ret,FALSE); // Call a proc/func with same name!
end;
//----------------------------------------------------
procedure  THtmlPscl.HTMLScript(Sender: TObject; const AName, ContentType, Src, Script: ThtString);
begin
   // ContentType: "text/pascalscript" On html file: "<script type="text/pascalscript" src="path\sobre.pscl"></script>"
   if (LowerCase( ContentType ) <> 'text/pascalscript') then EXIT;
   //
   // Src: (Sem SCR)
   if (Trim(Src) = '') then EXIT;
   // Src: "path\msscripts.pscl"
   Console('Type: ' + AnsiString(ContentType) + ' src: ' + AnsiString(src) );
   if (NOT FileExists(src)) then begin
       ConsoleHtmlPscl('Script: "'+AnsiString(src)+'" não encontrado!');
       exit;
   end;
   Self.ContentScript := AnsiString(src);                           // Put scriot name in "Self.ContentScript"
   LoadScript(AnsiString(src));
   //
end;
//----------------------------------------------------
procedure THtmlPscl.HTMLPanelCreate(Sender: TObject; const AName, AType, SRC: ThtString; Panel: ThvPanel);
begin
   try
     Console(AnsiString('HTMLPanelCreate: "'+ AName) + '" "' + AnsiString(Panel.ClassName) +'"' );
     Self.pscl.Register_Object(AnsiString(AName), Panel);     // Register html "panel" auto
   except
     ConsoleHtmlPscl('Erro no PanelCreate() ' + AnsiString(AName));
   end;
end;
//================================================================================================
procedure Register;
begin
  {$I uhtmlpscl_icon.ctrs}
  RegisterComponents('Angelim',[THtmlPscl]);
end;

end.
